//////////////////////////////////////////////////////////////////////////
//                                                                      //
// cosh.cpp -                                                           //
//                                                                      //
//                              //
//        .                          //
//                                                                      //
// Copyright (c) 2001 RC Module Inc.                                    //
//                                                                      //
//  :  ..                                                 //
//                                                                      //
//   $Revision:: 1     $      $Date:: 2/14/06 8:06p    $                //
//                                                                      //
//////////////////////////////////////////////////////////////////////////


#include "math.h"
#include "auxfd.h"

//  Ln(2) * 0x4000000000000000
const ULONG DTLN2=3196577161300663914;

#ifdef __cplusplus
extern "C" {
#endif

//     
extern ULONG _DTLN[64];

//       (   double)
inline ULONG SrvExp2(ULONG& Arg, int i, int& NewExp);

//      
//  (  Exp(x)   Exp(-x)   )
inline ULONG SrvExp1(ULONG Arg, int i);

// cosh --
//
//     
//
//    --.
//    CORDIC,    
double cosh(double f){

	LONG Mnt;               //   
	int Exp, Sgn;           //     
	int NewExp=0;           //      
	ULONG Arg;              //   
	ULONG rez;              //   
	ULONG mines_rez;        //    

    //   double
    DstrDouble( f, Mnt, Exp, Sgn );

	//  
    if ( Exp ==0x400 && Mnt==0 )					//  4 NAN
		return f;

	if ( Exp > 9 ){			//    
		if (!_FPIEEE_Flags)
			_FPIEEE_Signal( _FPIEEE_Overflow ); 
		return ConstructDouble( 0, 0x400, 0, 0);
	}

	int i=-11;      //   

    //     () ,  floor 
	if (Exp>=0){				
		Arg = Mnt << (Exp);
	}
	else if (Exp>=-2){
		Arg = Mnt << 4;
		Arg = Arg >> (-Exp);
		i=-7;
	}
	else {
		Arg = Mnt << 11;
		Arg = Arg >> (-Exp);
		i=0;
	}

    rez = SrvExp2( Arg, i, NewExp);
    NewExp--;
    if ( NewExp >30 ){          //  sh = exp(x)/2
	    if (NewExp>0x3ff){
			if (!_FPIEEE_Flags)
				_FPIEEE_Signal( _FPIEEE_Overflow ); 
			return ConstructDouble( 0, 0x400, 0, 0);	
	    }
    }
    else{                       // sh = (exp(x)-exp(-x))/2
    	Arg = DTLN2 - Arg;
        mines_rez = SrvExp1(Arg, 0);
        rez += mines_rez >> ((NewExp<<1)+3);
    }
    rez >>=9;	//    , ...
    rez = (rez>>1) + (rez & 1); //   ,  .

    if (rez & 0x0020000000000000){	
	    rez >>= 1;
	    NewExp++;
    }
    while (!(rez & 0x0010000000000000)){	
	    rez <<= 1;
	    NewExp--;
    }

    //   double
    return ConstructDouble( rez, NewExp, 0, 0);
}

#ifdef __cplusplus
}
#endif

//       (   double)
inline ULONG SrvExp2(ULONG& Arg, int i, int& NewExp){
    LONG tmp = Arg;
    ULONG RetArg;
	ULONG rez = 0x4000000000000000; 

	while (i<0){                //  
		i++;
		tmp -= DTLN2; 
		if (tmp>0){
			Arg = tmp;
			NewExp += 1 << (-i);
		}
		else                    //    - 
			tmp = Arg;
		tmp <<=1;
		Arg = tmp;
	}
	tmp >>=1;
	Arg = tmp;
    RetArg = Arg;
    while (i!=62){              //  
		tmp -= _DTLN[i++];      //    ,
                                //    ,  TLN[]
                                //  ,    
		if (tmp>0){
			rez += rez >> i;    //  - !
			Arg = tmp;
		}
		else                    //    - 
			tmp = Arg;
	}
    Arg = RetArg;
    return rez;
}

//      
//  (  Exp(x)   Exp(-x)   )
inline ULONG SrvExp1(ULONG Arg, int i){
	LONG tmp = Arg;             //       
	ULONG rez = 0x4000000000000000; 

    while (i!=62){              //  
		tmp -= _DTLN[i++];      //    ,
                                //    ,  TLN[]
                                //  ,    
		if (tmp>0){
			rez += rez >> i;    //  - !
			Arg = tmp;
		}
		else                    //    - 
			tmp = Arg;
	}
    return rez;
}
