//==============================================================================
//  Component:
//
//  Module:
//      $KW; $FN; $EKW;
//      $KW; $Own; $Ver; $ChkD; $EKW;
//
//  Purpose:
//
// [Keywords:]
//
//  Copyright (C) 1999-2001 Interstron, Ltd.
//  All rights reserved.
//==###=========================================================================

#include <typeinfo>
#include <assert.h>
#include <stddef.h>
#include "TryCatch.h"

#ifdef __cplusplus
    extern "C" {
#endif


    void* _dynamicCast(void* _this, struct TypeInfoClass* typeFrom, struct ClassInfoVTable** vtable, struct TypeInfoClass* typeTo)
    {
        vtable--;
        bool isPtr = typeTo->tag & etPointer;
        if(isPtr) typeTo = (TypeInfoClass*)((TypeInfo*)typeTo)->next;

        void* ret = NULL;
        if(_this && (*vtable)->offset >= 0 && typeTo->tag & etClass)
        {
            for(int i = 0; i < (*vtable)->size; i++)
            {
                if(typeTo == (*vtable)->derived[i].derived)
                {
                    for(i = 0; i < typeTo->size; i++)
                    {
                        if(typeFrom == typeTo->bases[i].type && typeTo->bases[i].vbase == -1)
                        {
                            ret = (char*)_this - typeTo->bases[i].offset;
                            break;
                        }
                    }
                    break;
                }
            }
        }

        int access = (void*)typeTo == &VOID_CATCH_INFO ? 0 : -1;
        if(_this && !ret)
        {
            for(int i = 0; i < (*vtable)->size; i++)
            {
                if(typeFrom == (*vtable)->derived[i].derived)
                {
                    access = (*vtable)->derived[i].access;
                    break;
                }
            }
        }

        if(_this && !ret && access == 0)
        {
            if((*vtable)->offset >= 0) _this = (char*)_this - (*vtable)->offset;
            else _this = *((void**)((char*)_this - (*vtable)->offset));
            if((void*)typeTo != &VOID_CATCH_INFO)
            {
                typeFrom = (*vtable)->type;
                if(typeTo == typeFrom || typeTo->tag & etTerm) ret = _this;
                else
                {
                    for(int i = 0; i < typeFrom->size; i++)
                    {
                        if(typeTo == typeFrom->bases[i].type)
                        {
                            if(typeFrom->bases[i].vbase != -1)
                            {
                                _this = *(void**)((char*)_this + typeFrom->bases[i].vbase);
                            }
                            ret = (char*)_this + typeFrom->bases[i].offset;
                            break;
                        }
                    }
                }
            }
            else ret = _this;
        }

        if(!ret && !isPtr) throw std::bad_cast();

        return ret;
    }

#ifdef __cplusplus
    }
#endif

//==###=========================================================================
//  End of module:
//      $KW; $FN; $EKW;
//==============================================================================
