//==============================================================================
//  Component:
//      STD (C++ Standard Library)
//
//  Library:
//      $KW; $FN; $EKW;
//      $KW; $Own; $Ver; $ChkD; $EKW;
//
//  Purpose:
//
//  Copyright (C) 1998-2001 Interstron, Ltd.
//  All rights reserved.
//==###=========================================================================
#include <exception>
#include <cstdlib>

namespace std {

#define HANDLER(name,func)                                                      \
    static name##_handler __current_##name##_handler = func;                    \
    name##_handler set_##name (name##_handler new_handler) throw()              \
    {                                                                           \
        name##_handler old_handler = __current_##name##_handler;                \
        __current_##name##_handler = new_handler;                               \
        return old_handler;                                                     \
    }                                                                           \
    void name ()                                                                \
    {                                                                           \
        (*__current_##name##_handler)();                                        \
    }
                                                                                       
HANDLER(terminate,(void(*)())abort)
   
HANDLER(unexpected,terminate)
    

bool
uncaught_exception ()
{
    return false;
}

} // namespace std
//==###=========================================================================
//  End of module:
//      $KW; $FN; $EKW;
//==============================================================================
