/*----------------------------------------------------------------
 *
 * NeuroChip NM6403, C run-time library
 * 1997-1998 (c) RC Module Inc.
 * printf.h,
 *
 *---------------------------------------------------------------- */

#ifndef	_PRINTF_H
#define	_PRINTF_H	1

#include <stddef.h>
#include <stdarg.h>		/* Need va_list.  */


struct printf_info
{
  int prec;			/* Precision.  */
  int width;			/* Width.  */
  unsigned char spec;		/* Format letter.  */
  unsigned int is_long_double:1;/* L flag.  */
  unsigned int is_short:1;	/* h flag.  */
  unsigned int is_long:1;	/* l flag.  */
  unsigned int alt:1;		/* # flag.  */
  unsigned int space:1;		/* Space flag.  */
  unsigned int left:1;		/* - flag.  */
  unsigned int showsign:1;	/* + flag.  */
  char pad;			/* Padding character.  */
};

typedef struct {
       char *s;
       int  ind;
} STRING;

typedef int printf_function (STRING * __stream,
				  const struct printf_info * __info,
				  va_list * __args);
enum
{				/* C type: */
  PA_INT,			/* int */
  PA_CHAR,			/* int, cast to char */
  PA_STRING,			/* const char *, a '\0'-terminated string */
  PA_POINTER,			/* void * */
  PA_FLOAT,			/* float */
  PA_DOUBLE,			/* double */
  PA_LAST
};

/* Flag bits that can be set in a type returned by `parse_printf_format'.  */
#define	PA_FLAG_MASK		0xff00
#define	PA_FLAG_LONG_LONG	(1 << 8)
#define	PA_FLAG_LONG_DOUBLE	PA_FLAG_LONG_LONG
#define	PA_FLAG_LONG		(1 << 9)
#define	PA_FLAG_SHORT		(1 << 10)
#define	PA_FLAG_PTR		(1 << 11)

#endif /* printf.h  */
