//////////////////////////////////////////////////////////////////////////
//                                                                      //
//               NeuroMatrix(r) STD (C++ Standard Library)              //
//                                                                      //
//  typeinfo.c                                                          //
//                                                                      //
// Copyright (c) 1998-2008 RC Module                                    //
//  If this code works, it was written by Alex Ruzavin                  //
//  If not, I don't know who wrote it.                                  //
//                                                                      //
// $Revision:: 2     $      $Date:: 2/01/08 1:56p    $                  //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#include <typeinfo>
#include <string.h>

#ifdef SPARC
asm (".global _vtbl__for__9type_info");
#endif

#ifdef MC68020
asm (".globl __vtbl__for__9type_info");
#endif

#ifdef NM6401
asm("extern __vtbl__for__9type_info : word;");
#endif

_NS_STD_BEGIN

#if !defined(__NM6403__) && !defined(__NM6405__)

/* class type_info member functions */
type_info::~type_info ()
{
}

bool
type_info::operator == (const type_info &rhs) const
{
	if (this == &rhs)
		return true;

	if (strcmp(name(), rhs.name()) == 0)
		return true;

	return false;
}

/*
  bool operator!=(const type_info& rhs) const;

  Returns:
    !(*this == rhs).
*/

bool type_info::operator!=(const type_info& rhs) const
{
    return !(*this == rhs );
}

bool
type_info::before (const type_info &rhs) const
{
	struct TIpair {
		type_info *info;
		int offset;
	} *next;

	for (next = (TIpair*) (this+1);
	     next->info != 0;
	     next++)

		if (next->info == &rhs ||
		    strcmp(next->info->name(), rhs.name()) == 0)
			return true;

	return false;
}

type_info::type_info (const type_info &r)
{
	_name = r.name();
}

type_info &
type_info::operator = (const type_info &r)
{
	_name = r.name();
	return *this;
}

/*
  const char* name() const;

  Returns:
    an implementation-defined value.
  Notes:
    The    message   may   be   a   null-terminated   multibyte   string
    (_lib.multibyte.strings_), suitable for conversion and display as  a
    wstring (_lib.wstring_, _lib.locale.codecvt_)
*/

const char* type_info::name() const
{
    return  _name;
}

#endif

_NS_STD_END
